<?php
/**
 *
 * Copyright notice
 *
 * (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

return call_user_func(
	function ($extKey, $table) {
		return [
			'ctrl' => [
				'title' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table,
				'label' => 'name',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => TRUE,
				'searchFields' => 'job_id, zip, city, state, country, description, name, street, contact',
				'versioningWS' => 2,
				'versioning_followPages' => TRUE,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				'delete' => 'deleted',
				'enablecolumns' => [
					'disabled' => 'hidden',
					'starttime' => 'starttime',
					'endtime' => 'endtime',
				],
				'sortby' => 'sorting',
				'iconfile' => 'EXT:' . $extKey . '/Resources/Public/Icons/' . $table . '.svg'
			],
			'interface' => [
				'showRecordFieldList' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, pid, job_id, zip, city, street name, state, country, description, contact',
			],
			'types' => [
				'1' => [
					'showitem' => '--palette--;;sysLanguageAndHidden,
					job_id, zip, city, street,name, state, country, description, contact;;;richtext[*]:rte_transform[mode=ts],
					--div--; LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:tca.seo_tab,
						identifying_url,
					--div--;LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:tabs.access, starttime, endtime',
				],
			],
			'palettes' => [
				'sysLanguageAndHidden' => [
					'showitem' => 'sys_language_uid;;;;1-1-1, l10n_diffsource, hidden;;1, ',
					'canNotCollapse' => 1,
				]
			],
			'columns' => [
				'sys_language_uid' => [
					'exclude' => 1,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.language',
					'config' => [
						'type' => 'select',
						'special' => 'languages',
					],
				],
				'l10n_parent' => [
					'displayCond' => 'FIELD:sys_language_uid:>:0',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.l18n_parent',
					'config' => [
						'type' => 'select',
						'items' => [
							['', 0],
						],
						'foreign_table' => $table,
						'foreign_table_where' => 'AND ' . $table . '.pid=###CURRENT_PID### AND ' . $table . '.sys_language_uid IN (-1,0)',
					],
				],
				'l10n_diffsource' => [
					'config' => [
						'type' => 'passthrough',
					],
				],
				't3ver_label' => [
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.versionLabel',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'max' => 255,
					]
				],
				'pid' => [
					'exclude' => 0,
					'label' => 'PID',
					'config' => [
						'type' => 'none',
					]
				],
				'hidden' => [
					'exclude' => 1,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.hidden',
					'config' => [
						'type' => 'check',
					],
				],
				'starttime' => [
					'exclude' => 1,
					'l10n_mode' => 'mergeIfNotBlank',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.starttime',
					'config' => [
						'type' => 'input',
						'size' => 13,
						'max' => 20,
						'eval' => 'datetime',
						'checkbox' => 0,
						'default' => 0,
						'range' => [
							'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
						],
					],
				],
				'endtime' => [
					'exclude' => 1,
					'l10n_mode' => 'mergeIfNotBlank',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.endtime',
					'config' => [
						'type' => 'input',
						'size' => 13,
						'max' => 20,
						'eval' => 'datetime',
						'checkbox' => 0,
						'default' => 0,
						'range' => [
							'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
						],
					],
				],
				'zip' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.zip',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'city' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.city',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'job_id' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.job_id',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'name' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.name',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'street' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.street',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'state' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.state',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'country' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.country',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'description' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.description',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'contact' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:tx_sgjobs_domain_model_job.contact',
					'config' => [
						'type' => 'select',
						'items' => [['', 0]],
						'renderType' => 'selectSingle',
						'internal_type' => 'db',
						'foreign_table' => 'tx_sgjobs_domain_model_contact',
						'foreign_table_where' => 'tx_sgjobs_domain_model_contact.hidden = FALSE',
						'size' => 1,
						'maxitems' => 1,
						'multiple' => 0,
						'fieldControl' => [
							'editPopup' => [
								'disabled' => FALSE,
							],
							'addRecord' => [
								'disabled' => FALSE,
							]
						],
					],
				],
				'identifying_url' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.identifyingUrl',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputLink',
						'fieldControl' => [
							'linkPopup' => [
								'options' => [
									'blindLinkFields' => 'class,target,title',
									'blindLinkOptions' => 'file,folder,mail,spec'
								],
							],
						],
					],
				],
			],
		];
	}, 'sg_jobs', 'tx_sgjobs_domain_model_company'
);
