<?php
/**
 * Copyright notice
 *
 * (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

return call_user_func(
	function ($extKey, $table) {
		return [
			'ctrl' => [
				'title' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table,
				'label' => 'title',
				'label_alt_force' => 1,
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => TRUE,
				'searchFields' => 'title',
				'versioningWS' => 2,
				'versioning_followPages' => TRUE,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				'delete' => 'deleted',
				'enablecolumns' => [
					'disabled' => 'hidden',
					'starttime' => 'starttime',
					'endtime' => 'endtime',
				],
				'sortby' => 'sorting',
				'iconfile' => 'EXT:' . $extKey . '/Resources/Public/Icons/' . $table . '.svg'
			],
			'interface' => [
				'showRecordFieldList' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, pid, title',
			],
			'types' => [
				'1' => [
					'showitem' => '--palette--;;sysLanguageAndHidden,
					title,
					--div--;LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:tabs.access, starttime, endtime',
				],
			],
			'palettes' => [
				'sysLanguageAndHidden' => [
					'showitem' => 'sys_language_uid;;;;1-1-1, l10n_diffsource, hidden;;1, ',
					'canNotCollapse' => 1,
				]
			],
			'columns' => [
				'sys_language_uid' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.language',
					'config' => [
						'type' => 'select',
						'foreign_table' => 'sys_language',
						'foreign_table_where' => 'ORDER BY sys_language.title',
						'items' => [
							['LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.allLanguages', -1],
							['LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.default_value', 0]
						],
					],
				],
				'l10n_parent' => [
					'displayCond' => 'FIELD:sys_language_uid:>:0',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.l18n_parent',
					'config' => [
						'type' => 'select',
						'items' => [
							['', 0],
						],
						'foreign_table' => $table,
						'foreign_table_where' => 'AND ' . $table . '.pid=###CURRENT_PID### AND ' . $table . '.sys_language_uid IN (-1,0)',
					],
				],
				'l10n_diffsource' => [
					'config' => [
						'type' => 'passthrough',
					],
				],
				't3ver_label' => [
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.versionLabel',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'max' => 255,
					]
				],
				'pid' => [
					'exclude' => FALSE,
					'label' => 'PID',
					'config' => [
						'type' => 'none',
					]
				],
				'hidden' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.hidden',
					'config' => [
						'type' => 'check',
					],
				],
				'starttime' => [
					'exclude' => TRUE,
					'l10n_mode' => 'mergeIfNotBlank',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.starttime',
					'config' => [
						'type' => 'input',
						'size' => 13,
						'max' => 20,
						'eval' => 'datetime',
						'checkbox' => 0,
						'default' => 0,
						'range' => [
							'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
						],
					],
				],
				'endtime' => [
					'exclude' => TRUE,
					'l10n_mode' => 'mergeIfNotBlank',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.endtime',
					'config' => [
						'type' => 'input',
						'size' => 13,
						'max' => 20,
						'eval' => 'datetime',
						'checkbox' => 0,
						'default' => 0,
						'range' => [
							'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
						],
					],
				],
				'title' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.title',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim,required'
					],
				]
			],
		];

	}, 'sg_jobs', 'tx_sgjobs_domain_model_department'
);
